/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import javax.swing.*;

import objets.*;

import java.awt.event.*;
import java.awt.*;
import Applet.*;

/**
 *
 * @author Yves
 * Bote de dialogue utilise pour entrer l'angle d'une rotation
 */
@SuppressWarnings("serial")
public class AngleRotDlg extends MtgDlg implements ActionListener {
  private EditeurAngle editeurAngle;
  private JButton btnOK, btnCancel;
  private CRotation rot;
  private PaneBoutonsListeValeursEtFonctionsCombo paneListeValeurEtFonctions;  
  
  /** Creates a new instance of AngleRotDlg */
  public AngleRotDlg(AppletMathGraph32 appletInit, CRotation rotInit) {
    super(AppletMathGraph32.getString("ch11"), true, appletInit);
    setResizable(false);
    rot = rotInit;
    JLabel label = new JLabel(AppletMathGraph32.getString("angleRotDlg1"), SwingConstants.LEFT);
    editeurAngle = new EditeurAngle(applet, rot.angle, rot, applet.listePr.uniteAngle);
    btnCancel = new JButton(AppletMathGraph32.getString("btnCancel"));
    btnOK = new JButton(AppletMathGraph32.getString("btnOK"));
    btnOK.setPreferredSize(btnCancel.getPreferredSize());
    CListeObjets liste = applet.listePourConstruction(); // Ajout version 4.6 
    int indmax = liste.indexOf(rot);
    if (indmax != -1) editeurAngle.setSelectedItem(rot.angle.chaineInfo());
    else {
    	indmax = liste.size() - 1;
    	editeurAngle.setSelectedIndex(-1);
    }
    paneListeValeurEtFonctions = new PaneBoutonsListeValeursEtFonctionsCombo(applet, editeurAngle, true, indmax, false);
    
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    JPanel paneBas = new JPanel(); // Pour contenir les boutons OK et Cancel
    paneBas.setLayout(new GridBagLayout());
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    
    setConstraints(constraints, 0, 0, 1, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(label, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 60, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.bottom = 0;
    pane.add(editeurAngle, constraints);
    constraints.insets.bottom = 5;
    
    setConstraints(constraints, 0, 1, 2, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.EAST);
    pane.add(paneListeValeurEtFonctions, constraints);
    
    setConstraints(constraints, 0, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneBas.add(btnOK, constraints);

    setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneBas.add(btnCancel, constraints);
    
    setConstraints(constraints, 0, 2, 2, 1, 0, 30, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
    pane.add(paneBas, constraints);
    
    setContentPane(pane);
    btnOK.addActionListener(this);
    btnCancel.addActionListener(this);
    getRootPane().setDefaultButton(btnOK);
    pack();
  }
  public void actionPerformed(ActionEvent evt) {
    if (evt.getSource()== btnOK) {
      // Si la rponse est valide, on ferme la boite de dialogue sans la dtruire.
      // VrifieValidite se charge de changer l'angle de la rotation si la rponse est
      // correcte.
      if (editeurAngle.verifieValidite()) {
        
        setRetourOK(true);
        dispose();
      }
    }
    else {
      if (evt.getSource() == btnCancel) {
        dispose();
      }
    }
    // La variable retourOK a t initialie  false donc tous les autres cas n'on pas  tre traits
  }  
}
