/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;
import Applet.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;


/**
 *
 * @author Yves
 * Ce type de dialogue sera ouvert lorsqu'on clique sur un bouton Liste des valeurs
 * dans une boite de dialogue permettant de spcifier un angle
 */
@SuppressWarnings("serial")
public class ListeValeursComboDlg extends MtgDlg implements ActionListener {
  private EditeurAngle editeur;   // Le combo d'entre d'angle associ
  @SuppressWarnings("unused")
	private int indiceMaxi;         // L'indice maxi dans la lsite d'objets du dernier objet qui puiss
                          // figurer dans le combo
  private ListeValeurs listeVal;
  private JButton btnOK, btnCancel;  
  
  
  /** Creates a new instance of ListeValeursComboDlg */
  public ListeValeursComboDlg(AppletMathGraph32 appletInit, EditeurAngle editeurInit,
      int indiceMaxiInit) {
    super(AppletMathGraph32.getString("listeValeursComboDlg1"),true, appletInit);
    this.setResizable(false);
    editeur = editeurInit;
    indiceMaxi = indiceMaxiInit;
    btnOK = new JButton(AppletMathGraph32.getString("btnOK"));
    btnCancel = new JButton(AppletMathGraph32.getString("btnCancel"));
    btnOK.setPreferredSize(btnCancel.getPreferredSize());
    // Pour la version applet on n'utilise que l'utilisation des calculs ou mesures
    // faits par l'utilisateur, c'est  dire les objets contenus dans listeConstruction
    // Pour cette raison le calcul pi est rajout  cette liste au chargement
    listeVal = new ListeValeurs(applet.listeConstruction, indiceMaxiInit);
    getContentPane().setLayout(new GridBagLayout());
    GridBagConstraints constraints = new GridBagConstraints();
    // Le combo s'tale sur deux colonnes
    setConstraints(constraints, 0, 0, 2, 1, 100, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
    //constraints.insets.bottom = 60;
    JScrollPane scrollList = new JScrollPane(listeVal, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    getContentPane().add(scrollList, constraints);
    constraints.insets.bottom = 0;
    
    setConstraints(constraints, 0, 1, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    getContentPane().add(btnOK, constraints);

    setConstraints(constraints, 1, 1, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    getContentPane().add(btnCancel, constraints);    
    btnOK.addActionListener(this);
    btnCancel.addActionListener(this);
    pack();  
  }

  public void actionPerformed(ActionEvent evt) {
    if (evt.getSource()== btnOK) {
      editeur.setSelectedItem(listeVal.getSelectedValue());
      dispose();
    }
    else {
      if (evt.getSource()== btnCancel) {
        dispose();
      }
    }   
  }

}
