/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;
import Applet.AppletMathGraph32;
import Applet.MtgPaneFigure;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CMacroTraceAuto extends CMacroAvecListe {
  public int nombrePointsPourTrace;
	// Frquence. Utile pour les macros excutes dans uns macro
	// excutant une suite d'autres macros
  public int frequenceAnimationMacro;
	public CPointLie pointLieAssocie;
  private double abscisse; // l'abscisse en cours du point li qui bouge
  private double abscisseMini;
  private double abscisseMaxi;
  private double pas;
  private double abscisseInitiale;
  private int indicePointEnCours; // Utilis dans le cas o la frquence est non nulle
  CListeObjets listeDep;

  /** Creates new CMacroTraceAuto */
  public CMacroTraceAuto() {
    // Modification de la version 1.8
  }
  
  // Constructeur pour clonage
  public CMacroTraceAuto(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit, CPointLie pointLieAssocieInit, int nombrePointsPourTraceInit,
      int frequenceAnimationMacroInit, int alignementHorizontalInit, int alignementVerticalInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit,x_nomInit, y_nomInit, dec_xInit, dec_yInit, 
      masqueInit, pointLieInit, indiceTaillePoliceInit, encadrementInit, effacementFondInit, couleurFondInit,
      intituleInit, commentaireMacroInit, listeAssocieeInit, alignementHorizontalInit, alignementVerticalInit);
    pointLieAssocie = pointLieAssocieInit;
    nombrePointsPourTrace = nombrePointsPourTraceInit;
    frequenceAnimationMacro = frequenceAnimationMacroInit;
    listeDep = new CListeObjets(liste);    
  }
 
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CSousListeObjets listeAssocieeClone = new CSousListeObjets();
    listeAssocieeClone.setImage(listeAssociee, listeSource, listeCible);
    int ind1 = listeSource.indexOf(pointLieAssocie);    
    int ind2 = listeSource.indexOf(pointLie); 
    int ind3 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroTraceAuto(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind2, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, listeAssocieeClone,
      (CPointLie) (listeCible.get(ind1, CPointLie.class)), nombrePointsPourTrace, frequenceAnimationMacro,
      alignementHorizontal, alignementVertical);
    ((CMacroTraceAuto) ptelb).listeDep = new CListeObjets(listeCible.uniteAngle, listeCible.pointeurLongueurUnite);
    return ptelb;
  }
  
  @Override
  public boolean dependDe(CElementBase p) {
  	if (elementTestePourDependDe == p) return dependDeElementTeste;
    return memoriseDependance(super.dependDe(p) || pointLieAssocie.dependDe(p));
  }
    
  @Override
  public boolean executionPossible() {
  	// Modification version 3.2.6
    // return pointLieAssocie.existe && listeAssociee.existeAuMoinsUnElement();
  	return pointLieAssocie.existe;
  }
  
  /**
   * Fonction prparant les listes dont la macro a besoin pour s'excuter
   */
  @Override
  public void etablitListesInternes() {
  	listeDep.retireTout();
    listeDep.ajouteObjetsDependantsSauf(pointLieAssocie, listeProprietaire, this);
  }
  // Ajout version 4.7.8.1
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListesInternes();
  }

  @Override
  public void actionAvantExecution(AppletMathGraph32 applet) {
  	super.actionAvantExecution(applet);  // Met executioEnCours  true
    // Rajout pour version 1.8
    applet.initialisetBuffer();   
    // On mmorise la position actuelle du point li
    abscisseInitiale = pointLieAssocie.abscisse;
    abscisseMini = pointLieAssocie.abscisseMinimale();
    abscisseMaxi = pointLieAssocie.abscisseMaximale();
    if (abscisseMini > abscisseMaxi) {
      double d = abscisseMini;
      abscisseMini = abscisseMaxi;
      abscisseMaxi = d;
    }
    // Modification pour la version 1.9.5
    int nbValeurs;
    // Modification pour la version 1.9.5
    if (pointLieAssocie.lieALigneFermee()) nbValeurs = nombrePointsPourTrace;
    else nbValeurs = nombrePointsPourTrace-1;
    
    
    // Ligne suivante modifie pour la version 1.8
    pas = (abscisseMaxi-abscisseMini)/nbValeurs;
    abscisse = abscisseMini - pas;
    timeDebut = System.currentTimeMillis();
    timeFin = timeDebut + 100000000; // Ce n'est pas timeFin qui compte mais le nombre de boucles
    indicePointEnCours = 0; // Pour le cas o la frquence est non nulle
    //if (dureeAnimation != 0) {
    //  timeFin = timeDebut + dureeAnimation*100; // La dure est en diximes de secondes
    //}
  }
 
  // Si lors de actionDansPaint(), appel dans paint(), la macro affiche d'abord
  // l'image de fond, cette procdure renvoie true (c'est le dfaut).
  // Renverra fausse pour les macros de trace et de trace automatique
  // ainsi que pour les macros de boucle avec trace d'objet
  @Override
  public boolean affichageSurImFond() {
    return false;
  }
  
  @Override
  public synchronized void actionDansPaint(AppletMathGraph32 applet) {
  	MtgPaneFigure paneFigure = applet.paneFigure;
    DimensionFenetre dimfen = applet.dimf;
    if (frequenceAnimationMacro == 0) {
      for (int i = 1; i <= nombrePointsPourTrace; i++) {
        abscisse = abscisse + pas;
        pointLieAssocie.donneAbscisse(abscisse);
        listeDep.positionne(applet.infRand, dimfen);
        // Modificatin pour version 1.8
        CMathGrafDoc doc = applet.document;
        listeAssociee.afficheToutMemeMasquesPourTrace(paneFigure.tbuffer, dimfen, doc.couleurFond, doc.transparencePourSurfaces,
        		applet.pref_antialiasing);
      }
      paneFigure.transferetbufferversgbuffer();
      paneFigure.afficheToutDansgbuffer();
      executionEnCours = false;     
    }
    else {
    	paneFigure.transferetbufferversgbuffer();
    	paneFigure.afficheToutDansgbuffer();
    }     
  }

  
  @Override
  public long dureePourAnimation() {
    return nombrePointsPourTrace*frequenceAnimationMacro*10;
  }

  @Override
  public synchronized void executePourTimer(AppletMathGraph32 applet, boolean repaint) {
    if (!executionEnCours) return;
    DimensionFenetre dimfen = applet.dimf;
    indicePointEnCours++;
    // Pour la ligne suivante il faut mettre un >= et non == en effet il se peut que
    // l'ordre repaint de la fin soit saut auquel cas on reviendra dans cette fonction
    // avec un indice suprieur
    if (indicePointEnCours >= nombrePointsPourTrace) abscisse = abscisseMaxi;
    else abscisse = abscisse + pas;
    pointLieAssocie.donneAbscisse(abscisse);
    listeDep.positionne(applet.infRand, dimfen);
    CMathGrafDoc doc= applet.document;
    listeAssociee.afficheToutMemeMasquesPourTrace(applet.paneFigure.tbuffer, dimfen, doc.couleurFond, doc.transparencePourSurfaces,
    		applet.pref_antialiasing);
    if (indicePointEnCours >= nombrePointsPourTrace) {
      // On leurre paint() dans l'applet en changeant le temps de dbut d'affichage
      timeFin = timeDebut;
    }
    // Des messages paint() peuvent se perdre. l'abscisse doit donc tre change dans actionPourPaint()
    if (repaint) applet.paneFigure.repaint();
  }

  @Override
  public void termineAction(AppletMathGraph32 applet) {
    super.termineAction(applet);
    MtgPaneFigure paneFigure = applet.paneFigure;
    pointLieAssocie.donneAbscisse(abscisseInitiale);
    listeDep.positionne(applet.infRand, applet.dimf);
    paneFigure.transferetbufferversgbuffer();
    paneFigure.afficheToutDansgbuffer();
  }

  @Override
  public int typeAnimation() {
    if (frequenceAnimationMacro == 0) return CMacro.sansAnimation;
    else return CMacro.animationParTimer;
  }

  @Override
  public int frequenceAnimation() {
    return frequenceAnimationMacro;
  }
  
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
  	if (pointLieAssocie == ancienPoint) pointLieAssocie = (CPointLie) nouveauPoint;
  }  
  
	/**
	 * Fonction renvoyant true si l'objet dpend des positions gnres pas les dplacements d'un point li
	 * A redfinir pour les lieux de points et lieux d'objets et macros utilisant les dplacements d'un point li
	 * @param pointlie
	 * @return
	 */
  @Override
	public boolean estGenereParPointLie(CPointLie pointlie) {
		return pointLieAssocie == pointlie;
	}
  	
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    nombrePointsPourTrace = inps.readCInt();
    frequenceAnimationMacro = inps.readCInt();   
    int ind1 = inps.readCInt();
    pointLieAssocie = (CPointLie) (list.get(ind1,CPointLie.class));
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }
  
  /* Lecture depuis dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    nombrePointsPourTrace = inps.readInt();
    frequenceAnimationMacro = inps.readInt();   
    int ind1 = inps.readInt();
    pointLieAssocie = (CPointLie) (list.get(ind1,CPointLie.class));
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }
  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeInt(nombrePointsPourTrace);
    oups.writeInt(frequenceAnimationMacro);
    int ind1 = list.indexOf(pointLieAssocie);
    oups.writeInt(ind1);
  }
}