/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 * Outil de cration d'une bissectrice
 */
package outils;

import objets.*;
import types.*;
import Applet.*;

public class OutilBis extends OutilPar3pts {
  
  /** Creates a new instance of OutilBis */
  public OutilBis(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, AppletMathGraph32.iconCreerDroiteBissectrice);
  }

  public int idMenu() {
    return 32791;
  }
  
  public String toolTip() {
    return getString("toolTip2");
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CBissectrice pt = new CBissectrice(appletMere.listePr, null, false, 
       appletMere.couleurActive(), appletMere.styleTraitActif(), point1, point2, point3, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil3"));
    annuleClignotement();
    // Provisoire
    select();
  }
  
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CBissectrice bis = new CBissectrice(liste, null, false, appletMere.couleurActive(),
    		appletMere.styleTraitActif(), point1, point2, appletMere.pointSouris, 2);
    liste.add(bis);
    CPointProjete ptproj = new CPointProjete(liste, null, false, Couleur.TraduitCouleur(1),
            true, MotifPoint.petitRond, point1,bis);
    liste.add(ptproj);
  	// On cre deux segments en pointills
  	CSegment pts1 = new CSegment(liste, null, false, point1, point2);
    liste.add(pts1);
  	CSegment pts2 = new CSegment(liste, null, false, point2, appletMere.pointSouris);
    liste.add(pts2);
    // On cre deux marques d'angle
    CMarqueAngleGeometrique ptma1 = new CMarqueAngleGeometrique(liste, null, false, 
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais, StyleMarqueAngle.marqueSimple, 11, point1, point2, ptproj);
    liste.add(ptma1);
    CMarqueAngleGeometrique ptma2 = new CMarqueAngleGeometrique(liste, null, false, 
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais, StyleMarqueAngle.marqueSimple, 14, ptproj,
      point2, appletMere.pointSouris);
    liste.add(ptma2);
  }
    /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants
   * @param i : l'indice
   * @return
   */

  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return getString("bissectrice1");
      case 2 : return getString("bissectrice2");
      case 3 : return getString("bissectrice3");
      default: return "";
    }
  }
  
}
