/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.*;
import dialogs.*;
import objets.*;
import types.*;
import Applet.*;


/**
 *
 * @author Yves
 */
public class OutilCerOR extends Outil {
  CPointAncetre point;
  CValeurAssocieeAVariable ray;
  CCercleOR ptCercle;
  /** Creates a new instance of OutilCerOR */
  public OutilCerOR(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true, AppletMathGraph32.iconCreerCercleOR);
  }

  public int idMenu() {
    return 32797;
  }
 
  public String toolTip() {
    return getString("toolTip6");
  }

  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    point = null;
    designationDe(NatureObjet.NToutPoint);
    appletMere.indication(getString("cercleOR1"));
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    if (appletMere.ajouteElementAvecVerification(ptCercle))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil5"));
    select();
  }

  /** Mthode renvoyant true seulement si l'outil peut tre slectionn.
   * A redfinir seulement pour les outils qui peuvent ventuellement tre
   * impossibles  slectionner, par exemple l'outil de cration d'un cercle
   * par son centre et son rayon si une longueur unit n'a pas t dfinie pour
   * la figure
  **/
  public boolean activationValide() {
    return (appletMere.listePr.pointeurLongueurUnite != null);
  }  
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    CListeObjets liste = appletMere.listePr;
    if (point == null) {
      appletMere.indication(getString("cercleOR2"));
      point = (CPointAncetre) elg;
      ajouteClignotementDe(elg);
      resetClignotement();
      ray = new CValeurAssocieeAVariable(liste, 0);
      ptCercle = new CCercleOR(liste, null, false, appletMere.couleurActive(),
          false, appletMere.styleTraitActif(),  point, ray, false);
      // On cre un dialogue modal permettant d'entrer l'angle de la rotation
      RayonDlg rayonDlg = new RayonDlg(appletMere, ptCercle);
      rayonDlg.setLocationRelativeTo(appletMere); // Pour centrer la boite de dialogue sur l'cran
      // On redessine la figure pour liminer la dsignation ce point affiche pur le centre
      appletMere.videDesignation();
      appletMere.repaintFigure();
      rayonDlg.setVisible(true);
      // On regarde si la bote de dialogue a bien t valide par OK
      if (rayonDlg.retourOK()) {
        creeObjet();
      }
      else {
        select(); 
      }
    }
  }      
}
