/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import Applet.AppletMathGraph32;
import java.awt.Point;

import dialogs.EntreeNomDlg;

import objets.CElementGraphique;

import types.NatureObjet;

/**
 *
 * @author Yves
 */
public class OutilEntrerNom extends Outil {
  /** Constructeur */
   public OutilEntrerNom(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true, AppletMathGraph32.iconNommer);
  }
  
  public String toolTip() {
    return getString("toolTip33");
  }
  
  /** Appel lorsque l'outil est slectionn */
  @Override
  public void select() {
    super.select();
    appletMere.outilPointageActif = appletMere.outilPointagePourNommer;
    appletMere.outilPointageActif.reset();
    designationDe(NatureObjet.NToutPoint | NatureObjet.NDroite | NatureObjet.NDroiteClone);
    appletMere.indication(getString("entreeNom1"));
  }
  @Override
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    ajouteClignotementDe(elg);
    EntreeNomDlg dlg = new EntreeNomDlg(appletMere, elg);
    dlg.setLocationRelativeTo(appletMere); // Pour centrer la boite de dialogue sur l'cran
    // On redessine la figure pour liminer la dsignation ce point affiche pur le centre
    appletMere.videDesignation();
    dlg.setVisible(true);
    select();
  }
}
