/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;
import Applet.*;
import java.awt.Color;
import java.awt.Point;
import javax.swing.BorderFactory;
import objets.*;
import types.FonteNom;

/**
 * Outil permettant  l'utilisateur de cliquer sur des objets pour proposer sa solution
 * @author Yves
 */
public class OutilPropSol extends Outil {
  int indiceObjetEnCours;
  /**
   * Constructeur
   * @param appletMereInit
   */
  public OutilPropSol(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true, null);
  }

  public String toolTip() {
    return getString("toolTip24");
  }
  
  public String chaineIndication (int indEtape) {
    return getString("ch8") + " " + appletMere.indicationSol(indEtape);
  }
  
    /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    indiceObjetEnCours = 1;
    appletMere.annuleSolutionProposee();
    CElementBase elb =(CElementBase) appletMere.listeAConstruire.get(0);
    appletMere.outilPointageActif = appletMere.outilPointagePropSol;
    appletMere.outilPointageActif.reset();
    designationDe(elb.naturePourConst());
    appletMere.indication(chaineIndication(1));
  }
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    appletMere.listeProposee.add(elg);
    ajouteClignotementDe(elg);
    resetClignotement();
    indiceObjetEnCours++;
    if (indiceObjetEnCours <= appletMere.listeAConstruire.size()) {
      CElementBase elb =(CElementBase) appletMere.listeAConstruire.get(indiceObjetEnCours-1);
      // Bug corrig version 4.7.2.7
      // designationDe(elb.getNature());
      designationDe(elb.naturePourConst());
      appletMere.indication(chaineIndication(indiceObjetEnCours));
   }
    else creeObjet();
  }
  /* On va maintenant regarder si les objets cliqus sont les bons */
  public void creeObjet() {
    appletMere.constructionExacte = appletMere.reponseValide();
    annuleClignotement();
    appletMere.activeOutilCapture();
    appletMere.indication(getString("validationSol"));
  }
  
  /**
   * 
   * @return Renvoie un pointeur sur le bouton correspondant  l'outil cr
   * ou null si l'outil est interdit pour la figure
   * Est redfini pour cet outil car il n'est pas dfini  partir d'un gif
   */
  // Modifi version 3.1.1
  @Override
  public MtgButton boutonAssocie() {
    // Si l'item de l'outil est 0, c'est que le bouton correspondant
    // doit figurer toujours dans la barre d'outils
    MtgButton button = new MtgButton(appletMere, getString("solution"), this);
    button.setBorder(BorderFactory.createEmptyBorder(2, 4, 2, 4));
    button.setForeground(Color.red);
    button.setFont(FonteNom.getFonteNom(3, FonteNom.Gras));      
    button.setToolTipText(toolTip());
    return button;
  }
  
}