/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package types;

import Applet.AppletMathGraph32;
/*
 * Class.java
 *
 * Created on 6 juillet 2004, 14:41
 */

/**
 *
 * @author  Yves
 * @version 
 */// Classe servant  dfinir les noms d'oprateurs de fonctions prdfinis

public class OperateurFonction {

  /** Creates new Class */
  public OperateurFonction () {
  }
  // Modifi version 4.6 pour rajouter deux fonctions Left et Right qui fournissent pour un test
  // le membre de gauche et le membre de droite.
  // public static final int nombreFonctionsReelles1Var = 19;
  public static final int nombreFonctionsReelles1Var = 22; // Corrig version 4.7.2
  public static final byte Abso = 0;
  public static final byte Raci = 1;
  public static final byte Enti = 2;
  public static final byte Sinu = 3;
  public static final byte Cosi = 4;
  public static final byte Tang = 5;
  public static final byte Logn = 6;
  public static final byte Expo = 7;
  public static final byte ATan = 8;
  public static final byte ACos = 9;
  public static final byte ASin = 10;
  public static final byte Cosh = 11;
  public static final byte Sinh = 12;
  public static final byte Tanh = 13;
  public static final byte ArgCh = 14;
  public static final byte ArgSh = 15;
  public static final byte ArgTh = 16;
  public static final byte Rand = 17;
  public static final byte Raci2 = 18;
  // Nouvel oprateur pour version 3.0 : factorielle
  public static final byte fact = 19;
  // Deux nouveaux oprateurs pour la version 4.6 : Left et Right
  public static final byte Left = 20;
  public static final byte Right = 21;
  // Modification version 3.0 : dcalage pour faire de la place  factorielle et  d'autres futures fonctions
  /*
  // Dbut des fonctions complexes
  public static final byte Abs = 19;
  public static final byte Sin = 20;
  public static final byte Cos = 21;
  public static final byte Tan = 22;
  public static final byte Log = 23;
  public static final byte Exp = 24;
  public static final byte Ch = 25;
  public static final byte Sh = 26;
  public static final byte Th = 27;
  public static final byte Rnd = 28;
  public static final byte Conj = 29;
  public static final byte Arg = 30;
  public static final byte Re = 31;
  public static final byte Im = 32;
  public static final byte Rac = 33;
  public static final byte Rac2 = 34;
  public static final byte EntiC = 35;
  public static final byte ACosC = 36;
  public static final byte ASinC = 37;
  public static final byte ATanC = 38;
  public static final byte ArgChC = 39;
  public static final byte ArgShC = 40;
  public static final byte ArgThC = 41;
  */

  // Modifi version 4.6 pour rajouter deux fonctions Left et Right qui fournissent pour un test
  // le membre de gauche et le membre de droite.
  // public static final int nombreFonctionsComplexes1Var = 24;
  public static final int nombreFonctionsComplexes1Var = 26;

  public static final int indPremiereFoncComplexe = 64;
  
  public static final byte Abs = 64;
  public static final byte Sin = 65;
  public static final byte Cos = 66;
  public static final byte Tan = 67;
  public static final byte Log = 68;
  public static final byte Exp = 69;
  public static final byte Ch = 70;
  public static final byte Sh = 71;
  public static final byte Th = 72;
  public static final byte Rnd = 73;
  public static final byte Conj = 74;
  public static final byte Arg = 75;
  public static final byte Re = 76;
  public static final byte Im = 77;
  public static final byte Rac = 78;
  public static final byte Rac2 = 79;
  public static final byte EntiC = 80;
  public static final byte ACosC = 81;
  public static final byte ASinC = 82;
  public static final byte ATanC = 83;
  public static final byte ArgChC = 84;
  public static final byte ArgShC = 85;
  public static final byte ArgThC = 86;  
  // Nouvel oprateur pour version 3.0 : factorielle
  public static final byte factC = 87;
  // Deux nouveaux oprateurs pour la version 4.6 : Left et Right
  public static final byte LeftC = 88;
  public static final byte RightC = 89;
  // Fonction ajoute version 4.7.9 pour tester l'quivalence de deux fonctions car il y a deux oprateurs pour les racines carres
  public static final boolean estEquivalent(int b1, int b2) {
  	return (b1 == b2) || ((b1 == Raci) && (b2 == Raci2)) || ((b1 == Raci2) && (b2 == Raci)) || ((b1 == Rac) && (b2 == Rac2)) || ((b1 == Rac2) && (b2 == Rac));
  }
  public static final String nomsFonctions[] =
	{
  	getString("abs"),getString("sqrt"),getString("intgr"),getString("sin"),
  	getString("cos"),getString("tan"),getString("ln"),getString("exp"),getString("arctan"),
		getString("arccos"),getString("arcsin"),getString("ch"),getString("sh"),
		getString("th"),getString("argch"),getString("argsh"),getString("argth"),
		getString("rand"),getString("rac"),getString("fact"),getString("left"),getString("right")
	};

  public static final String nomsFonctionsComplexes[] = {
  	getString("abs"),getString("sin"),getString("cos"),getString("tan"),getString("ln"),
  	getString("exp"),getString("ch"),getString("sh"),getString("th"),getString("rand"),
  	getString("conj"),getString("arg"),getString("re"),getString("im"),
  	getString("sqrt"),getString("rac"),getString("intgr"), getString("arccos"),
  	getString("arcsin"),getString("arctan"),getString("argch"),getString("argsh"),
  	getString("argth"), getString("fact"), getString("left"), getString("right")
  };

  public static final String syntaxeNomsFonctions[] =
	{
  	getString("infoabs"),getString("infosqrt"),getString("infointgr"),getString("infosin"),
  	getString("infocos"),getString("infotan"),getString("infoln"),getString("infoexp"),getString("infoarctan"),
		getString("infoarccos"),getString("infoarcsin"),getString("infoch"),getString("infosh"),
		getString("infoth"),getString("infoargch"),getString("infoargsh"),getString("infoargth"),
		getString("inforand"),getString("inforac"),getString("infofact"),getString("infoLeft"), getString("infoRight")
	};

  public static final String syntaxeNomsFonctionsComplexes[] = {
  	getString("infoabs"),getString("infosin"),getString("infocos"),getString("infotan"),getString("infoln"),
  	getString("infoexp"),getString("infoch"),getString("infosh"),getString("infoth"),getString("inforand"),
  	getString("infoconj"),getString("infoarg"),getString("infore"),getString("infoim"),
  	getString("infosqrt"),getString("inforac"),getString("infointgr"), getString("infoarccos"),
  	getString("infoarcsin"),getString("infoarctan"),getString("infoargch"),getString("infoargsh"),
  	getString("infoargth"), getString("infofact"), getString("infoLeft"), getString("infoRight")
  };
  
  public static final String getString(String key) {
  	return AppletMathGraph32.getString(key);
  }
  
}
